require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "vinx.material.textfield.MaterialTextField"
import "com.google.android.material.materialswitch.MaterialSwitch"
import "com.google.android.material.button.MaterialButton"
import "androidx.appcompat.widget.AppCompatSpinner"
import "com.google.android.material.textview.MaterialTextView"
import "com.google.android.material.dialog.MaterialAlertDialogBuilder"

import "github.daisukiKaffuChino.utils.LuaThemeUtil"


projectdir = ...

MDC_R=luajava.bindClass"com.google.android.material.R"
pcall(dofile,projectdir.."/config/lua_theme.lua")
local last_theme = last_theme or "BlueTheme"
local APP_THEME = import("themes."..last_theme)
this.setTheme(APP_THEME)
this.getWindow()
.setStatusBarColor(primaryColor)
.setNavigationBarColor(primaryColor)

require "permission"
local layout={
  ScrollView,
  layout_width="fill";
  {
    LinearLayout;
    layout_width="fill";
    orientation="vertical";
    {
      LinearLayout;
      layout_width="fill";
      orientation="vertical";
      layout_marginLeft="16dp";
      layout_marginRight="16dp";
      {
        MaterialTextField;
        hint="名称";
        layout_width="fill";
        layout_marginTop="8dp";
        id="appname";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="版本";
        layout_width="fill";
        layout_marginTop="8dp";
        id="appver";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="Code";
        layout_width="fill";
        layout_marginTop="8dp";
        id="appcode";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };

      {
        MaterialTextField;
        hint="SDK";
        layout_width="fill";
        layout_marginTop="8dp";
        id="appsdk";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="关联";
        layout_width="fill";
        layout_marginTop="8dp";
        id="path_pattern";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="包名";
        layout_width="fill";
        layout_marginTop="8dp";
        id="packagename";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="作者";
        layout_width="fill";
        layout_marginTop="8dp";
        id="developer";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
      {
        MaterialTextField;
        hint="描述";
        layout_width="fill";
        layout_marginTop="8dp";
        id="description";
        singleLine=true;
        style=MDC_R.style.Widget_Material3_TextInputLayout_OutlinedBox,
        tintColor = colorPrimary
      };
    };
    {
      LinearLayout;
      orientation="horizontal";
      layout_width="fill";
      {
        MaterialTextView;
        text="主题";
        textSize="16sp";
        layout_marginLeft="16dp";
      };
      {
        AppCompatSpinner;
        id="tlist";
      };
    };
    {
      MaterialSwitch;
      id="debugmode";
      text="调试";
      padding="16dp";
      layout_width="fill";
      textSize="16sp";
    };
    {
      MaterialButton;
      text="更改权限";
      id="btn",
      layout_width="fill";
      layout_margin="16dp";
    };
  };

}

activity.setTitle('工程属性')
MDC_R=luajava.bindClass"com.google.android.material.R"
activity.setContentView(loadlayout(layout))

--plist=ListView(activity)
--[[
dlg=MaterialAlertDialogBuilder(activity)

dlg.title="更改权限"
--dlg.view=plist
dlg.setPositiveButton("确定",nil)]]
btn.onClick=function()
  --dlg.show()
  local checkedList={}
  for index,content in ipairs(ps) do
    table.insert(checkedList,not not(pcs[content]))
  end
  MaterialAlertDialogBuilder(this)
  .setTitle("更改权限")
  .setMultiChoiceItems(pss,checkedList,function(dialog,which,isChecked)
    checkedList[which+1]=isChecked
  end)
  .setPositiveButton("关闭",function()
    --table.clear(rs)
    for index,content in ipairs(ps) do
      pcs[content]=checkedList[index]
      --[[
      if checkedList[index] then
        
        --table.insert(rs,content)
      end]]
    end
  end)
  .show()
end


luaproject=projectdir.."/init.lua"
app={}
loadfile(luaproject,"bt",app)()
appname.Text=app.appname or "OpenLua"
appver.Text=app.appver or "1.0"
appcode.Text=app.appcode or "1"
appsdk.Text=app.appsdk or "15"
path_pattern.Text=app.path_pattern or ""
packagename.Text=app.packagename or "com.openlua"
developer.Text=app.developer or ""
description.Text=app.description or ""
debugmode.Checked=app.debugmode==nil or app.debugmode

--plist.ChoiceMode=ListView.CHOICE_MODE_MULTIPLE;
pss={}
ps={}
for k,v in pairs(permission_info) do
  table.insert(ps,k)
end
table.sort(ps)

for k,v in ipairs(ps) do
  table.insert(pss,permission_info[v])
end

--adp=ArrayListAdapter(activity,android.R.layout.simple_list_item_multiple_choice,String(pss))
--plist.Adapter=adp
--rs=app.user_permission or {}

pcs={}
for k,v in ipairs(app.user_permission or {}) do
  pcs[v]=true
end
--[=[
checked={}
for k,v in ipairs(ps) do
  table.insert(checked,pcs[v] or false)
  --[[
  if pcs[v] then
    plist.setItemChecked(k-1,true)
  end]]
end]=]
--[[
dlg.setMultiChoiceItems(String(pss), (checked), nil)
dlg=dlg.create()
--dlg.show()
plist=dlg.getListView()]]


local fs=luajava.astable(android.R.style.getFields())
local tss={"Theme"}
for k,v in ipairs(fs) do
  local nm=v.Name
  if nm:find("^Theme_") then
    table.insert(tss,nm)
  end
end

tadp=ArrayAdapter(activity,android.R.layout.simple_list_item_1, String(tss))
tlist.Adapter=tadp

for k,v in ipairs(tss) do
  if v==app.theme then
    tlist.setSelection(k-1)
  end
end

function callback(c,j)
  print(dump(j))
end

local template=[[
appname="%s"
appver="%s"
appcode="%s"
appsdk="%s"
path_pattern="%s"
packagename="%s"
theme="%s"
developer="%s"
description="%s"
debugmode=%s
user_permission={
  %s
}
]]
local function dump(t)
  for k,v in ipairs(t) do
    t[k]=string.format("%q",v)
  end
  return table.concat(t,",\n  ")
end

function onCreateOptionsMenu(menu)
  menu.add("保存").setShowAsAction(1)
end

--rs={}
function onOptionsItemSelected(item)
  if appname.Text=="" or appver.Text=="" or packagename.Text=="" then
    Toast.makeText(activity,"项目不能为空",500).show()
    return true
  end
  --[[
  local cs=plist.getCheckedItemPositions()
  local rs={}
  for n=1,#ps do
    if cs.get(n-1) then
      table.insert(rs,ps[n])
    end
  end]]
  local rs={}
  for n=1,#ps do
    if pcs[ps[n]] then
      table.insert(rs,ps[n])
    end
  end
  local thm=tss[tlist.getSelectedItemPosition()+1]
  local ss=string.format(template,appname.Text,appver.Text,appcode.Text,appsdk.Text,path_pattern.Text,packagename.Text,thm,developer.Text,description.Text,debugmode.isChecked(),dump(rs))
  local f=io.open(luaproject,"w")
  f:write(ss)
  f:close()
  Toast.makeText(activity, "已保存.", Toast.LENGTH_SHORT ).show()
  activity.result({appname.Text})
end

local lastclick=os.time()-2
function onKeyDown(e)
  local now=os.time()
  if e==4 then
    if now-lastclick>2 then
      Toast.makeText(activity, "再按一次返回", Toast.LENGTH_SHORT ).show()
      lastclick=now
      return true
    end
  end
end
