local _M = {}
local Magnifier = luajava.bindClass "github.znzsofficial.widget.magnifier.CustomMagnifier";
_M.Available=false
_M.inited = false
_M.view = nil

local sp=this.getSharedPreferences("Magnifier",0)
local editor = sp.edit()
function setSharedData(k,v)
  editor.putFloat(k,tonumber(v)).apply()
end

function getSharedData(k,def)
  return sp.getFloat(k,def or 100)
end

_M.setSharedData = setSharedData
_M.getSharedData = getSharedData

_M.initMagnifier=function(view)
  _M.view = view
  _M.inited = true
  if not(getSharedData("mHeight")
    and getSharedData("mWidth")
    and getSharedData("mZoom"))
    setSharedData("mHeight",160)
    setSharedData("mWidth",320)
    setSharedData("mZoom", 1.25)
    _M.magnifier = Magnifier(_M.view)
    .setCornerRadius(24)
    .setZoom(1.25)
    .setDimensions(320,160)
   else
    _M.reset()
  end
end

_M.isNearChar=function(editor,relativeCaretX,relativeCaretY,x,y)
  local TOUCH_SLOP=editor.getTextSize()+10
  return (y >= (relativeCaretY - TOUCH_SLOP)
  and y < (relativeCaretY + TOUCH_SLOP+100)
  and x >= (relativeCaretX - TOUCH_SLOP-40)
  and x < (relativeCaretX + TOUCH_SLOP+40))
end

_M.show=function(view,relativeCaretX,relativeCaretY,eventX,eventY)
  local magnifierX=eventX
  local magnifierY=relativeCaretY-view.getTextSize()/2+2
  _M.magnifier.show(magnifierX, magnifierY);
end

_M.reset=function()
  _M.magnifier = Magnifier(_M.view)
  .setCornerRadius(24)
  .setZoom(getSharedData("mZoom"))
  .setDimensions(getSharedData("mWidth"),getSharedData("mHeight"))
end

_M.hide=function()
  _M.magnifier.dismiss()
end

return _M